=head1 NAME

Gtk2::CV::Util - utility functions

=head1 SYNOPSIS

  use Gtk2::CV::Util;

=head1 DESCRIPTION

=head2 METHODS

=over 4

=cut

package Gtk2::CV::Util;

use common::sense;
use Gtk2 ();

sub interpret_keymap {
   my ($keymap, $actions, $self, $key, $state) = @_;

   if ($keymap->{state_prepare}) {
      $state = $keymap->{state_prepare}($state, $self);
   } else {
      $state *= Gtk2::Accelerator->get_default_mod_mask;
   }

   for my $onstate (reverse @{ $keymap->{states} }) {
      if ($state == $onstate->{state}) {
         if (($onstate->{cond} || sub { 1 })->($self, $key, $state)) {
            if (my $action = $onstate->{keys}{$key}) {

               unless (ref $action) {
                  $action =~ y/-/_/;
                  $action = $actions->{$action}
               }

               if ($action) {
                  $action->($self, $key, $state);
                  return 1;
               } else {
                  return 0;
               }
            }
         }
      }
   }

   0
}

=back

=head1 AUTHOR

Marc Lehmann <schmorp@schmorp.de>

=cut

1

